"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __exportStar = (this && this.__exportStar) || function(m, exports) {
    for (var p in m) if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports, p)) __createBinding(exports, m, p);
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.utils = exports.logging = exports.error = exports.config = exports.authorization = exports.logger = void 0;
exports.parseJwtFromRequestAuthenticationHeader = parseJwtFromRequestAuthenticationHeader;
exports.JWTVerify = JWTVerify;
const jose_1 = require("jose");
const url_1 = require("url");
const errors_js_1 = require("./errors.js");
__exportStar(require("./database/abstractDataSource.js"), exports);
__exportStar(require("./database/abstractRepository.js"), exports);
__exportStar(require("./errors.js"), exports);
__exportStar(require("./handlers/index.js"), exports);
var index_js_1 = require("./logging/index.js");
Object.defineProperty(exports, "logger", { enumerable: true, get: function () { return index_js_1.logger; } });
__exportStar(require("./types.js"), exports);
exports.authorization = __importStar(require("./authorization/index.js"));
exports.config = __importStar(require("./config.js"));
exports.error = __importStar(require("./error_middleware.js"));
exports.logging = __importStar(require("./logging/index.js"));
exports.utils = __importStar(require("./utils.js"));
/**
 * @deprecated It should not be necessary to verify the JWT. Use the authorization server instead.
 */
function parseJwtFromRequestAuthenticationHeader(req) {
    const jwt = req.header('X-Request-Authentication');
    if (jwt === undefined) {
        throw new errors_js_1.JWTVerificationError('Authorization header is not set', 401);
    }
    if (!jwt)
        throw new errors_js_1.JWTVerificationError('No JWT provided', 401);
    return jwt;
}
/**
 * @deprecated It should not be necessary to verify the JWT. Use the authorization server instead.
 */
function JWTVerify(options, validatePayload, parseJwt) {
    const jwksUrl = new url_1.URL(options.JWKS_URL);
    const JWKS = (0, jose_1.createRemoteJWKSet)(jwksUrl);
    return async (req, scopes) => {
        const jwt = parseJwt(req);
        if (!jwt)
            throw new errors_js_1.JWTVerificationError('No JWT provided', 401);
        const jwtVerifyResult = await (0, jose_1.jwtVerify)(jwt, JWKS, {
            issuer: options.SECURITY_ISSUER,
            audience: options.SECURITY_AUDIENCE,
        });
        const user = jwtVerifyResult.payload;
        user.jwt = jwt;
        if (!validatePayload(user))
            throw new errors_js_1.JWTVerificationError('Payload is malformed', 401);
        let scopeFound = false;
        for (const scope of scopes) {
            // eslint-disable-next-line @typescript-eslint/no-explicit-any
            if (user.scopes.includes(scope)) {
                scopeFound = true;
                break;
            }
        }
        if (!scopeFound)
            throw new errors_js_1.JWTVerificationError('Missing Scope: one of ' + scopes, 403);
        return user;
    };
}
//# sourceMappingURL=index.js.map