import { DataSource, DataSourceOptions } from 'typeorm';
import { AbstractRepository } from './abstractRepository.js';
type RepositoryDict = {
    [k: string]: AbstractRepository<object, unknown, unknown, Record<string, object>>;
};
export declare abstract class AbstractApplicationDataSource<RD extends RepositoryDict> {
    private _dataSource;
    private entityManager?;
    repositories: RD;
    connected: boolean;
    constructor(options: DataSourceOptions);
    protected abstract createRepositories(): RD;
    private initializeRepositories;
    initialize(options?: DataSourceOptions): Promise<void>;
    teardown(): Promise<void>;
    get dataSource(): DataSource;
    transaction<T>(runInTransaction: (repositories: RD) => Promise<T>): Promise<T>;
}
export {};
//# sourceMappingURL=abstractDataSource.d.ts.map